#!/usr/bin/perl -- # -*- perl -*-

use CGI;

require "codelib.pl";
$TempFile::TMPDIRECTORY='./tmp'; 

$query = new CGI;

sub errormsg {
    my ($errortxt) = @_;
    print "Content-type: text/html\n\n";
    print "<HTML>\n<HEAD>\n";
    print "<TITLE>Add Pinyin Error</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print $errortxt, "<P>";
    print " Please try again. \n</BODY>\n</HTML>";
    exit;
}

$filehandle = $query->param('file');

if ($query->param('encoding') eq "autodetect") {
    $linecount = 0;
    while (<$filehandle>) {
	$filetxt .= $_;
	$readlines[$linecount] = $_;
	if ($linecount == 150) { last;}
	$linecount++;
    }
    @guesses = codeguess($filetxt);
    if ($guesses[0] eq "other" or $guesses[0] eq "hz") {
	errormsg("File encoding must be either GB, Big5, or UTF-8");
    }
    $query->param('encoding', $guesses[0]);
    print stderr "guesses is " , $guesses[0], "\n";
    print stderr "new encoding val is ", $query->param('encoding'), "\n";
}


if ($query->param('encoding') eq "big5") {
    &initB5;
} elsif ($query->param('encoding') eq "gb") {
    &initGB;
} elsif ($query->param('encoding') eq "utf8") {
    &initU8;
} 

print "Content-type: text/plain\n\n";


foreach $urlline (@readlines) {
    print &sinofy;
}

while ($urlline = <$filehandle>) {
    $linecount++;
    print &sinofy;
}

close $filehandle;

$tmpfilename = $query->tmpFileName($filehandle);
unlink $tmpfilename;


if ($linecount == 0) {
    print "<HTML>\n<HEAD>\n";
    print "<TITLE>File Not Found or Empty</TITLE>\n</HEAD>\n";
    print "<BODY><H1>File Not Found or Empty</H1>\n";
    print "The file you requested either does not exist or is empty.";
    print "If you are sure that the file does exist and is not empty, please e-mail ";
    print "me at <A HREF=\"mailto:yourname\@yourserver.com\">yourname@yourserver.com</A> and I will try to find the problem.<BR>\n";
    print "File: ", $query->param('file'), " <BR>\n";
    print "Level: ", $query->param('level'), " <BR>\n";
    print "How Many: ", $query->param('howmany'), " <BR>\n";
    print "Encoding: ", $query->param('encoding')," <BR>\n";
    print "</BODY>\n</HTML>\n";
    exit;
}
				
sub sinofy {		        
    $outline = "";
    $linelen = length($urlline);
    for ($i = 0; $i < $linelen; $i++) {
	$char = substr($urlline, $i, 1);
	$binchar = vec($urlline, $i, 8); # 
	if ($binchar <= 127) {
	    $outline .= $char;	# 
	} else {		# 
	    if ($query->param('encoding') eq "utf8") {
		if ($binchar >= 0xC0 and $binchar <= 0xDF) {
		    $char = substr($urlline, $i, 2); # 
		} elsif ($binchar >= 0xE0 and $binchar <= 0xEF) {
		    $char = substr($urlline, $i, 3);
		$i++;
		}		# 
	    } else {
		$char = substr($urlline, $i, 2);
	    }
	    $pyval = "";
	    for ($j = $query->param('level'); $j < 10; $j++) {
		$pyval = $charlist[$j]{$char};
		if ($pyval) { 
		    if ($query->param('howmany') eq "onetime") { 
			delete $charlist[$j]{$char};
		    }
		    last;
		};
	    }
	    $i++;
	    if ($pyval) { 
		$outline .= $char . ".$pyval.";
	    } else {
		$outline .= $char;
	    }
	}
    }

    $outline;
}


sub initB5 {
    open(B5PY, "b5py.freq") || errormsg("Can't open b5py.tab\n");
    $charsread = 0;
    while ($b5line = <B5PY>) {
#	print "$b5line<BR>";
	chop($b5line);
	($b5char, $pinyin) = split(/\t/,$b5line);
	if ($charsread >= 0 && $charsread < 500) {
	    $charlist[0]{$b5char} = $pinyin;
	} elsif ($charsread >= 500 && $charsread < 1000) {
	    $charlist[1]{$b5char} = $pinyin;
	} elsif ($charsread >= 1000 && $charsread < 1500) {
	    $charlist[2]{$b5char} = $pinyin;
	} elsif ($charsread >= 1500 && $charsread < 2000) {
	    $charlist[3]{$b5char} = $pinyin;
	} elsif ($charsread >= 2000 && $charsread < 2500) {
	    $charlist[4]{$b5char} = $pinyin;
	} elsif ($charsread >= 2500 && $charsread < 3000) {
	    $charlist[5]{$b5char} = $pinyin;
	} elsif ($charsread >= 3000 && $charsread < 3500) {
	    $charlist[6]{$b5char} = $pinyin;
	} elsif ($charsread >= 3500 && $charsread < 4000) {
	    $charlist[7]{$b5char} = $pinyin;
	} elsif ($charsread >= 4000 && $charsread < 4500) {
	    $charlist[8]{$b5char} = $pinyin;
	} else {
	    $charlist[9]{$b5char} = $pinyin;
	}
	$charsread++;
    }
}

sub initGB {
    open(GBPY, "gbpy.freq") || errormsg("Can't open GB table\n");
    while ($gbline = <GBPY>) {
	chop($gbline);
	($gbchar, $pinyin) = split(/\t/,$gbline);
	if ($charsread >= 0 && $charsread < 500) {
	    $charlist[0]{$gbchar} = $pinyin;
	} elsif ($charsread >= 500 && $charsread < 1000) {
	    $charlist[1]{$gbchar} = $pinyin;
	} elsif ($charsread >= 1000 && $charsread < 1500) {
	    $charlist[2]{$gbchar} = $pinyin;
	} elsif ($charsread >= 1500 && $charsread < 2000) {
	    $charlist[3]{$gbchar} = $pinyin;
	} elsif ($charsread >= 2000 && $charsread < 2500) {
	    $charlist[4]{$gbchar} = $pinyin;
	} elsif ($charsread >= 2500 && $charsread < 3000) {
	    $charlist[5]{$gbchar} = $pinyin;
	} elsif ($charsread >= 3000 && $charsread < 3500) {
	    $charlist[6]{$gbchar} = $pinyin;
	} elsif ($charsread >= 3500 && $charsread < 4000) {
	    $charlist[7]{$gbchar} = $pinyin;
	} elsif ($charsread >= 4000 && $charsread < 4500) {
	    $charlist[8]{$gbchar} = $pinyin;
	} else {
	    $charlist[9]{$gbchar} = $pinyin;
	}
	$charsread++;
    }
}


sub initU8 {
    open(U8PY, "uni8py.freq") || errormsg("Can't open uni8py.tab\n");
    $charsread = 0;
    while ($u8line = <U8PY>) {
#	print "$u8line<BR>";
	chop($u8line);
	($u8char, $pinyin) = split(/\t/,$u8line);
	if ($charsread >= 0 && $charsread < 500) {
	    $charlist[0]{$u8char} = $pinyin;
	} elsif ($charsread >= 500 && $charsread < 1000) {
	    $charlist[1]{$u8char} = $pinyin;
	} elsif ($charsread >= 1000 && $charsread < 1500) {
	    $charlist[2]{$u8char} = $pinyin;
	} elsif ($charsread >= 1500 && $charsread < 2000) {
	    $charlist[3]{$u8char} = $pinyin;
	} elsif ($charsread >= 2000 && $charsread < 2500) {
	    $charlist[4]{$u8char} = $pinyin;
	} elsif ($charsread >= 2500 && $charsread < 3000) {
	    $charlist[5]{$u8char} = $pinyin;
	} elsif ($charsread >= 3000 && $charsread < 3500) {
	    $charlist[6]{$u8char} = $pinyin;
	} elsif ($charsread >= 3500 && $charsread < 4000) {
	    $charlist[7]{$u8char} = $pinyin;
	} elsif ($charsread >= 4000 && $charsread < 4500) {
	    $charlist[8]{$u8char} = $pinyin;
	} else {
	    $charlist[9]{$u8char} = $pinyin;
	}
	$charsread++;
    }
}
